Provide a list of gccld optimization switches.
[oota-llvm.git] / utils / findmisopt
1 #!/bin/bash
2 #
3 #  findmisopt
4 #
5 #      This is a quick and dirty hack to potentially find a misoptimization
6 #      problem. Mostly its to work around problems in bugpoint that prevent
7 #      it from finding a problem unless the set of failing optimizations are
8 #      known and given to it on the command line.
9 #
10 #      Given a bytecode file that produces correct output (or return code), 
11 #      this script will run through all the optimizations passes that gccas
12 #      uses (in the same order) and will narrow down which optimizations
13 #      cause the program either generate different output or return a 
14 #      different result code. When the passes have been narrowed down, 
15 #      bugpoint is invoked to further refine the problem to its origin. If a
16 #      release version of bugpoint is available it will be used, otherwise 
17 #      debug.
18 #
19 #   Usage:
20 #      findmisopt bcfile outdir progargs [match]
21 #
22 #   Where:
23 #      bcfile 
24 #          is the bytecode file input (the unoptimized working case)
25 #      outdir
26 #          is a directory into which intermediate results are placed
27 #      progargs
28 #          is a single argument containing all the arguments the program needs
29 #      match
30 #          if specified to any value causes the result code of the program to
31 #          be used to determine success/fail. If not specified success/fail is
32 #          determined by diffing the program's output with the non-optimized
33 #          output.
34 #       
35 if [ "$#" -lt 3 ] ; then
36   echo "usage: findmisopt bcfile outdir progargs [match]"
37   exit 1
38 fi
39
40 dir="${0%%/utils/findmisopt}"
41 if [ -x "$dir/Release/bin/bugpoint" ] ; then
42   bugpoint="$dir/Release/bin/bugpoint"
43 elif [ -x "$dir/Debug/bin/bugpoint" ] ; then
44   bugpoint="$dir/Debug/bin/bugpoint"
45 else
46   echo "findmisopt: bugpoint not found"
47   exit 1
48 fi
49
50 bcfile="$1"
51 outdir="$2"
52 args="$3"
53 match="$4"
54 name=`basename $bcfile .bc`
55 ll="$outdir/${name}.ll"
56 s="$outdir/${name}.s"
57 prog="$outdir/${name}"
58 out="$outdir/${name}.out"
59 optbc="$outdir/${name}.opt.bc"
60 optll="$outdir/${name}.opt.ll"
61 opts="$outdir/${name}.opt.s"
62 optprog="$outdir/${name}.opt"
63 optout="$outdir/${name}.opt.out"
64
65 echo "Test Name: $name"
66 echo "Unoptimized program: $prog"
67 echo "  Optimized program: $optprog"
68
69 # Create output directory if it doesn't exist
70 if [ -f "$outdir" ] ; then
71   echo "$outdir is not a directory"
72   exit 1
73 fi
74
75 if [ ! -d "$outdir" ] ; then
76   mkdir "$outdir" || exit 1
77 fi
78
79 # Generate the disassembly
80 llvm-dis "$bcfile" -o "$ll" -f || exit 1
81
82 # Generate the non-optimized program
83 llc "$bcfile" -o "$s" -f || exit 1
84 gcc "$s" -o "$prog" -lstdc++ -lc -lm || exit 1
85
86 # Define the list of optimizations to run. This comprises the same set of 
87 # optimizations that gccas and gccld run, in the same order.
88 all_switches="-verify -lowersetjmp -funcresolve -raiseallocs -simplifycfg -mem2reg -globalopt -globaldce -ipconstprop -deadargelim -instcombine -simplifycfg -prune-eh -inline -simplify-libcalls -argpromotion -raise -tailduplicate -simplifycfg -scalarrepl -instcombine -predsimplify -condprop -tailcallelim -simplifycfg -reassociate -licm -loop-unswitch -instcombine -indvars -loop-unroll -instcombine -load-vn -gcse -sccp -instcombine -condprop -dse -dce -simplifycfg -deadtypeelim -constmerge -funcresolve -internalize -ipsccp -globalopt -constmerge -deadargelim -inline -prune-eh -globalopt -globaldce -argpromotion -instcombine -predsimplify -scalarrepl -globalsmodref-aa -licm -load-vn -gcse -dse -instcombine -simplifycfg -verify"
89 # Here's an alternative list of optimizations comprising just the ones that 
90 # gccld uses. To use, just comment out the line above, and uncomment this one
91 #all_switches="-funcresolve -internalize -ipsccp -globalopt -constmerge -deadargelim -inline -prune-eh -globalopt -globaldce -argpromotion -instcombine -predsimplify -scalarrepl -globalsmodref-aa -licm -load-vn -gcse -dse -instcombine -simplifycfg -verify"
92
93 # Current set of switches is empty
94 function tryit {
95   switches_to_use="$1"
96   opt $switches_to_use "$bcfile" -o "$optbc" -f || exit
97   llvm-dis "$optbc" -o "$optll" -f || exit
98   llc "$optbc" -o "$opts" -f || exit
99   gcc "$opts" -o "$optprog" -lstdc++ -lc -lm || exit
100   "$prog" $args > "$out" 2>&1
101   ex1=$?
102   "$optprog" $args > "$optout" 2>&1
103   ex2=$?
104
105   if [ -n "$match" ] ; then
106     if [ "$ex1" -ne "$ex2" ] ; then
107       echo "Return code not the same with these switches:"
108       echo $switches
109       echo "Unoptimized returned: $ex1"
110       echo "Optimized   returned: $ex2"
111       return 0
112     fi
113   else
114     diff "$out" "$optout" > /dev/null
115     if [ $? -ne 0 ] ; then
116       echo "Diff fails with these switches:"
117       echo $switches
118       echo "Differences:"
119       diff "$out" "$optout" 
120       return 0;
121     fi
122   fi
123   return 1
124 }
125
126 echo "Trying to find optimization that breaks program:"
127 for sw in $all_switches ; do
128   echo -n " $sw"
129   switches="$switches $sw"
130   if tryit "$switches" ; then
131     break;
132   fi
133 done
134
135 final=""
136 while [ ! -z "$switches" ] ; do
137   trimmed=`echo "$switches" | sed -e 's/^ *\(-[^ ]*\).*/\1/'`
138   switches=`echo "$switches" | sed -e 's/^ *-[^ ]* *//'`
139   echo "Trimmed $trimmed from left"
140   tryit "$final $switches"
141   if [ "$?" -eq "0" ] ; then
142     echo "Still Failing .. continuing ..."
143     continue
144   else
145     echo "Found required early pass: $trimmed"
146     final="$final $trimmed"
147     continue
148   fi
149   echo "Next Loop"
150 done
151
152 if [ "$final" == " $all_switches" ] ; then
153   echo "findmisopt: All optimizations pass. Perhaps this isn't a misopt?"
154   exit 0
155 fi
156 echo "Smallest Optimization list=$final"
157
158 bpcmd="$bugpoint -run-llc -disable-loop-extraction --output "$out" --input /dev/null $bcfile $final --args $args"
159
160 echo "Running: $bpcmd"
161 $bpcmd
162 echo "findmisopt finished."